/* Include */
#include <pthread.h>
#include <stdio.h>
#include <stdlib.h>
#include <string.h>

pthread_mutex_t mutex = PTHREAD_MUTEX_INITIALIZER;

int count;

void *IncrCount(void *id) {
   int index = *((int *) id);
   pthread_mutex_lock(&mutex);
   count++;
   printf("Thread %d:", index); 
   printf(" Count value: %d\n", count);
   pthread_mutex_unlock(&mutex);
   pthread_exit(NULL);
}

int main (int argc, char *argv[])
{
   pthread_t* threads;
   int* taskids;
   int N;
   int rc, t;
   
   if (argc != 2) {
      printf("ERROR: wrong number of arguments\n");
      exit(-1);
   }
   N = atoi(argv[1]);
   threads  = (pthread_t *) malloc(N * sizeof(pthread_t));
   taskids = malloc(N * sizeof(int));
   count = 0;
   for(t=0; t < N; t++){
      taskids[t] = t;  
      printf("Creating thread %d\n", t);
      rc = pthread_create(&threads[t], NULL, IncrCount, (void*) &taskids[t]);
      if (rc){
         printf("ERROR; return code from pthread_create() is %d\n", rc);
         exit(-1);
      }
   }
   pthread_exit(NULL);
}
