/* Include */
#include <pthread.h>
#include <semaphore.h>
#include <stdio.h>
#include <stdlib.h>
#include <string.h>

#define NUM_THREADS 5

struct my_type {
   int index;
   int sleep;
};

sem_t ready_thread[NUM_THREADS]; 

void *SleepnWake(void *x) {
   int i, temp;
   struct my_type* pars = (struct my_type *) x;
   printf("Thread %d: Started!\n", pars->index);
   sleep(pars->sleep);
   printf("Thread %d: Woken up after %d s!\n", pars->index, pars->sleep);
   
   for (i = 0; i < NUM_THREADS; i++) 
	sem_post(&ready_thread[pars->index]);
	
   for (i = 0; i < NUM_THREADS; i++) 
	if (pars->index != i) 
		sem_wait(&ready_thread[i]);
	
   printf("Thread %d: Closing!\n", pars->index);
   pthread_exit(NULL);
}

int main (int argc, char *argv[])
{
   pthread_t threads[NUM_THREADS];
   struct my_type taskpars[NUM_THREADS];
   int rc, t;
   
   if (argc != NUM_THREADS + 1) {
      printf("ERROR: wrong number of arguments\n");
      exit(-1);
   }
   
   for(t=0; t < NUM_THREADS; t++) {
      taskpars[t].index = t;  
      taskpars[t].sleep = atoi(argv[t+1]);  
      sem_init(&ready_thread[t], 0, 0);
      printf("Creating thread %d (%d s sleep)\n", t, atoi(argv[t+1]));
      rc = pthread_create(&threads[t], NULL, SleepnWake, (void*) &taskpars[t]);
      if (rc){
         printf("ERROR; return code from pthread_create() is %d\n", rc);
         exit(-1);
      }
   }
   
   for(t=0; t<NUM_THREADS; t++) {
	void* status;
	pthread_join(threads[t], (void **)&status);
   }
   pthread_exit(NULL);
}
