/* Include */
#include <pthread.h>
#include <semaphore.h>
#include <stdio.h>
#include <stdlib.h>
#include <string.h>

#define NUM_THREADS 5

struct my_type {
   int index;
   int sleep;
};

int ready = 0;
pthread_cond_t all_ready;
pthread_mutex_t mutex = PTHREAD_MUTEX_INITIALIZER;

void *SleepnWake(void *x) {
   int i, temp;
   struct my_type* pars = (struct my_type *) x;
   printf("Thread %d: Started!\n", pars->index);
   sleep(pars->sleep);
   printf("Thread %d: Woken up after %d s!\n", pars->index, pars->sleep);
   
   pthread_mutex_lock(&mutex);
   ready++;
   while (ready < NUM_THREADS)
	   pthread_cond_wait(&all_ready, &mutex);
   pthread_cond_signal(&all_ready);
   pthread_mutex_unlock(&mutex);
   
   printf("Thread %d: Closing!\n", pars->index);
   pthread_exit(NULL);
}

int main (int argc, char *argv[])
{
   pthread_t threads[NUM_THREADS];
   struct my_type taskpars[NUM_THREADS];
   int rc, t;
   
   if (argc != NUM_THREADS + 1) {
      printf("ERROR: wrong number of arguments\n");
      exit(-1);
   }
   
   for(t=0; t < NUM_THREADS; t++) {
      taskpars[t].index = t;  
      taskpars[t].sleep = atoi(argv[t+1]);  
      printf("Creating thread %d (%d s sleep)\n", t, atoi(argv[t+1]));
      rc = pthread_create(&threads[t], NULL, SleepnWake, (void*) &taskpars[t]);
      if (rc){
         printf("ERROR; return code from pthread_create() is %d\n", rc);
         exit(-1);
      }
   }
   
   for(t=0; t<NUM_THREADS; t++) {
	void* status;
	pthread_join(threads[t], (void **)&status);
   }
   pthread_exit(NULL);
}
