#include <stdio.h>
#include <pthread.h>
#include <semaphore.h>
#include <stdlib.h>

#define TCOUNT 10
#define COUNT_LIMIT 5

int count;
pthread_mutex_t count_mutex = PTHREAD_MUTEX_INITIALIZER;
pthread_cond_t count_threshold_cv = PTHREAD_COND_INITIALIZER;

void *inc_count(void *idp) {
  int j,i; double result=0.0; int *my_id = (int*) idp;
  printf("Starting inc_count(): thread %d\n", *my_id);
  for (i=0; i<TCOUNT; i++) {
    pthread_mutex_lock(&count_mutex);
    count++;
    if (count == COUNT_LIMIT) { /* Check the value of count and signal */
      pthread_cond_signal(&count_threshold_cv);
      printf("inc_count(): thread %d, count = %d Threshold reached.\n", *my_id, count);
    }
    printf("inc_count(): thread %d, count = %d, unlocking mutex\n", *my_id, count);
    pthread_mutex_unlock(&count_mutex);
    /* Do some work so threads can alternate on mutex lock */
    sleep(1);
  }
  pthread_exit(NULL);
}

void *watch_count(void *idp) {
  int *my_id = (int*) idp;
  printf("Starting watch_count(): thread %d\n", *my_id);
  pthread_mutex_lock(&count_mutex); /*Lock mutex and wait for signal. */
  printf("Mutua esclusione: count %d, LIMIT: %d\n", count, COUNT_LIMIT);
  while (count < COUNT_LIMIT) {
    pthread_cond_wait(&count_threshold_cv, &count_mutex);
    printf("watch_count():thread %d Condition signal received.\n",*my_id);
  }
  pthread_mutex_unlock(&count_mutex);
  pthread_exit(NULL);
}

int main (int argc, char *argv[]) {
  int i, rc, res;
  pthread_t threads[3];
  int ids[3] = {0, 1, 2};
  count = 0;
  /* Create threads and wait for all threads to complete */
  rc = pthread_create(&threads[0], NULL, inc_count, (void*) &ids[0]);
  if (rc){
    printf("ERROR; return code from pthread_create() is %d\n", rc);
    exit(-1);
  }
  rc = pthread_create(&threads[1], NULL, inc_count, (void*) &ids[1]);
  if (rc){
    printf("ERROR; return code from pthread_create() is %d\n", rc);
    exit(-1);
  }
  rc = pthread_create(&threads[2], NULL, watch_count, (void*) &ids[2]);
  if (rc){
    printf("ERROR; return code from pthread_create() is %d\n", rc);
    exit(-1);
  }
  /* Clean up and exit */
   for(i=0; i<3; i++) {
	void* status;
	pthread_join(threads[i], (void **)&status);
   }
   pthread_exit(NULL);
}